######################################################################################
# Before running this code, input your p-values into a column vector entitled "pval" #
######################################################################################

# This line assumes you have your p-values in a vector called "pval"
totalpvals <- length(pval)

original_sorting_order <- 1:length(pval)
sorted_indices <- order(pval)
rank <- rank(pval)

qval <- 1

bh95_qval <- rep(1, length(pval))

while (qval > 0) {
  fdr_temp <- qval * rank / totalpvals
  reject_temp <- ifelse(fdr_temp >= pval, 1, 0)
  reject_rank <- reject_temp * rank
  total_rejected <- max(reject_rank, na.rm = TRUE)  
  bh95_qval[rank <= total_rejected] <- qval
  qval <- qval - 0.001
}

# Restoring the original sorting order
sorted_indices_inverse <- order(original_sorting_order)
bh95_qval <- bh95_qval[sorted_indices_inverse]

cat("Code has completed.\n")
cat("Benjamini Hochberg (1995) q-vals are in vector bh95_qval\n")
cat("Sorting order is the same as the original vector of p-values\n")
